program L3DJumpBugFix;

uses
  Classes, SysUtils;

var
  i: Integer;
  MS: TMemoryStream;
  WordPtr: ^Word;

  function LevelFilename(aIndex: Integer): String;
  begin
    if aIndex < 10 then
      Result := 'LEVEL.00' + IntToStr(aIndex)
    else
      Result := 'LEVEL.0' + IntToStr(aIndex);
  end;

begin
  MS := TMemoryStream.Create;
  try
    for i := 0 to 99 do
    begin
      if not FileExists(LevelFilename(i)) then Continue;
      MS.LoadFromFile(LevelFilename(i));
      if MS.Size <> 66048 then Continue; // probably compressed, and thus, probably official level
      WordPtr := MS.Memory + $11B;
      WordPtr^ := WordPtr^ and $FFFC; // and (not $0003) - remove the incorrectly set flags
      if (WordPtr^ and $1000) <> 0 then WordPtr^ := WordPtr^ or $0008; // add the disable quick jump flag that should've been there
      MS.SaveToFile(LevelFilename(i));
    end;
  finally
    MS.Free;
  end;
end.

